/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2016-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */
import { SColor, SLine, SPainter, SPoint, SRect } from "@persagy-web/draw/";
import { SBaseImageEdit } from './../../edit';
import { SGraphItem } from "@persagy-web/graph";
import { Marker } from "./../../big-edit/types/Marker";
import { SMouseEvent } from "@persagy-web/base/lib";
import { ItemOrder } from '@persagy-web/big/lib';

/**
 * 编辑基础图片类
 *
 * * @author  韩耀龙(han_yao_long#163.com)
 */
export class SPersagyImageEdit extends SBaseImageEdit {
    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //属性

    constructor(parent: SGraphItem | null, data: Marker) {
        super(parent, data);
    }
    /**
     * 鼠标按下事件
     *
     * @param   event   保存事件参数
     * @return  boolean
     */
    onMouseDown(event: SMouseEvent): boolean {
        super.onMouseDown(event)
        return true;
    } // Function onMouseDown()

    /**
     * 返回对象储存的相关数据
     *
     * @return	formData
     */
    toData() {
        return super.toData()
    }

    /**
     * 鼠标按下事件
     *
     * @param   event   保存事件参数
     * @return  boolean
    */
    onDoubleClick(event: SMouseEvent): boolean {
        let dom = document.createElement('input');
        dom.type = "file";
        dom.name = "file";
        dom.accept = "image/*"
        dom.click();
        let that = this;
        dom.onchange = function (a) {
            //继续使用上文的fileList
            let file = a.path[0].files[0];
            const fileReader = new FileReader()
            fileReader.readAsDataURL(file) //读取图片
            fileReader.addEventListener('load', function () {
                // 读取完成
                let res = fileReader.result;
                console.log(fileReader, 'sersrf')
                that.url = res
                // res是base64格式的图片
            })
        }
        // super.onMouseDown(event)
        return true;
    } // Function onMouseDown()

}